Dragon Engine
Whats New

*
Beta 1.20

New Features:

- New spell types:
  Time Stop, Summon Monser, Invisibility, Cause Fright, Haste, Resurrect, 
  Poison, Clone, Teleport to Target, Teleport/Direction (blink), Spell 
  Immunity, Protection, Locate Coordinates, and Protection vs. Traps
- Renamed Negate Magic to Dispell Magic (negate magic will mean something
  else later)
- Creatures can now cast spells!  They cannot cast spells of all types.
  Spells they can cast: Heal, Cure, Damage, Charm, Sleep, Awaken, Dispell
  Magic, Summon Monster, Invisibility, Haste, Resurrect, Poison, Clone,
  Spell Immunity, Protection.
  Spells they cannot cast: Unlock Magic, View, Create Item, Grant Light, 
  Destroy Item, Time Stop, Cause Fright, Teleport/Target, Teleport/Direction,
  Locate Coordinates, and Protection vs. Traps (all of these are impractical
  for creatures to use).
- Rings can now be set to only work for a specified number of minutes (turns).
- Chests may now be trapped and may be set to any of the 255 possible key
  types.  Also when adding a chest to a monster or map you can now view and
  edit the chest types before chosing.
- Damage spells may now be limited to only one category of monster (for
  instance, spells that only damage undead or goblins)
- Three new flags added to creature attributes: monster class (affects class
  specific damage spell, see previous), teleportation, and see invisible.
- Improved creature AI (somewhat)
- New screen in stats showing enchantments cast on player (haste, invis, etc)
- With summoned monsters, clones, or charmed monsters, you may order them
  to leave when the battle is over by pressing [O] on their turn.
- Automatic targetting in battles!  Press N for next traget, P for previous
  target.

Bug Fixes:

- Fixed some problems with moon phases, monster generators, and other events
  triggered at certain hours.
- It is no longer possible to set the active player to an empty slot
- Changed the new order command (works better now)
- Fixed a bug with monster sounds where invalid sound #s were popping up
- It's no longer possible to aim outside of room borders in battle
- Monsters can no longer attack players who have left a room
- Sped up the aim cursor.  This only applys to aiming manually (with the
  arrow keys).

*
 
*
Beta 1.10
04/19/2000

- All title animation and room data files compressed into single data
files.  Now program consists of only 101 files.
- XP values for level increases now calculated correctly
- HP/Level1 may now be set to 100 (maximum was 99 before)
- Starting items enabled (this is set to one of the chest types)
- Changed transport functionality a bit.  A transport may now be set to pass
over any or all of the 5 different barrier types (C from item menu).
- New spell types!  Negate Magic, Charm, Sleep, Awake.  More coming soon.
- Realized that the spinning doodad in the corner of the screen was causing
data to sometimes be corrupted.  Removed it, replaced with hourglass pointer.
- Fix an upper limitation on memory problem.  Can now expand the engine as
much as it needs to be expanded.
- In example game, new spells for sale and fixed a few problems (like the
weird combat in the eastern town).
- Fixed a problem where, in rooms, you could move a pc around the screen
even after he had left the room
- Fixed misc bugs in the editor menus
- Arrow keys/space bar for menu options works more intelligently now

*

*
Beta 1.01
04/12/2000

Bugfixes:
- Sleeping NPCs no longer talk in their sleep
- Fixed a loop bug where if you talked to a dead NPC you would get stuck
- Party members afflicted with poison or other status ailments will have
their name highlighted in blue in the upper-right
- In the tile select/tile attributes screen, fixed background as background6,
since other background made it difficult to read important text
- Fixed a problem in NPC conversations where words which were not keywords 
were being highlighted in yellow

Example Game:
- Touched up some NPCs on the glenn map

*

*
Beta 1.0
04/11/2000

New Features:
Too many for me to remember them all and then list them!
Here are some highlights:
- Day/night and moon phases added
- Lighting effects added
- Complete documentation!  Readme.txt redone and it now covers everything
  in the editor.
- NPC Schedules now possible (more in readme.txt)
- Sound support improved, midi playback and fx sound better
- Randomized backgrounds in the editor menus
- Improved mouse support (see readme.txt)
- Tile groupings make map editing much easier
- Format of all data FINAL!  Any game you make now will work with all
  future versions.
- Logic improvements in tile attributes, creature attributes, and item
  attributes
- Multiple options for the starting party (see readme.txt, Globals)
- One more command added, [H]ole up & camp (maps only!  Not in rooms).
- Event layer greatly expanded (more in readme.txt)
- Introduction and endgame sequences added
- Full-screen FLI movie playback for endgame and introduction sequences
- 255 kinds of keys and locked doors possible
- Several bugs fixed
- Items/events may now display full screen graphics (more in readme.txt)
- New example game!  Overall a visual improvement over the previous one,
  but at this point it is incomplete.  Still there is a lot of area to
  explore.

Whats Left (What I plan on adding eventually)
- Spellcasting for monsters
- Mouse support in playgame
- First-person dungeons as an option (... maybe)
- Other than that, this is a complete program!

*

*
Alpha 8D
10/26/99
New Features:
- Cast spell in battles/rooms enabled.  This includes all of the damage
spells.  Graphical effects for these is forthcoming.
- Border when playing game is now animated and redone!
- Animated the flame tiles
- New tile type: damage.  For lava, etc.
- NPCs can now give items directly to the player.  This same keyword event
can also complete a quest.  This is a safeguard to prevent the player from
typing this same keyword over and over again and keep recieving the same item.
(For an example, see Eleanor in Sparta).
- NPC keywords can now require an item.  This work in two ways.  One is for a
payment type scenario (takes the item from the player in exchange for the
keyword event).  The second simply preforms a check for the item, and if it's
present, triggers the event.
- Added another NPC keyword requirement, "Quest is not completed".  The
opposite of Quest is completed.  Now an event can occur only if a certain
quest# has not yet been completed.  Useful in situations such as the above
example.

New in Example Game:
- Magically locked areas of the castle completed.
- You can find a scroll of open in one of the caves (for unlocking the doors
in the castle).  This will reappear everytime you go into this cave.
- As an alternative, someone in the game will sell you the open spell itself.
Can you find him?  Hint: You will need to complete a subquest involving
several NPCs and items before the open spell becomes available.
- Sparta, the town northwest of the castle, has been completed.   There is
another PC here.
- Corrected some spelling mistakes
- Left the hidden dungeon in, but made it more difficult (hopefully
difficult enough ... spells are proving to be quite powerful).

Bugfixes:
- Fixed a bug where when pressing escape to abort from the "Who Casts?"
prompt it tried to cast a spell anyway
- Fixed a bug in spellcasting where the spell effect was not always correct
- Fixed a few bugs related to problems when in dungeon areas
- Fixed a bug where when switching party order, party member spellbooks 
would get switched

*

*
Alpha 8C
10/19/99
New Features:
- Radius type sounds added!  For both items and tiles.  Assign a sound to an
item or tile, then assign a radius to it, and this sound will be heard as you
approach the item/tile.  If you approach from the left, the sound will pan
in from the right, and vice versa from the other direction.  In the example
game, torches, fountains, and clocks are all using radius sounds now.
- Added a new event type, Portal/Room.  This works exactly like the normal
portal except that it leads to a series of rooms instead of a new map.
- Room editor expanded!  You can now create a series of rooms which is
linked togethor, to form a dungeon type area.  This is useful because
everytime the party enters a series of rooms it will be reset, all of the
monsters and items will be repopulated.  Good for making leveling-up type
places and dungeons.
- Spell editor completed!  Create spells that heal, cure, view the area
from above, unlock magic, create items, or deal combat damage.  Have them
require items, or not.  I'll add more spell types soon.
- Cast spell in play game enabled.  This only works on maps right now, not
in rooms or combat.
- Added a new NPC keyword event, NPC sells spells, for selling spells to
party members.
- More new graphics from Geoff Jones and a couple by me
- Since gold can now be in the tens of thousands, increased the value
property for items accordingly
- Some new MIDs included.  Some of these were downloaded from free MIDI sites
and I have not yet gained official permission to include these.  But seeing
as the  midis were free and I'm not charging money for this I dont see how
this could cause any trouble.

New in the example game:
- Arcalia (to the northeast of Castle Sabian) completed.  You can buy spells
here, and there is someone who will join your party.
- "Gems" done away with and replaced by several different kinds of gems
which are now required to cast spells (for more information go to the hall of
records in Arcalia).
- Three caves can now be entered from the main map.  Good for leveling up.
The one closest to the castle is good at low levels, the other two are fairly
difficult.
- You can enter Sparta (to the northwest of Castle Sabian) but nobody is
there yet.
- This is the last alpha that will include the hidden dungeon in it's present
form.  If you plan on playing through it, now would be the time (although
you could always keep a copy of alpha 8 and play it later).
- It might be a good idea not to put too much time into the example game at
this point, because you'll need to start over once the next alpha comes out.

Bugs Fixed:
- Fixed the bug that caused you to only be able to select the first 8 classes
when making an NPC
- Fixed the bug where after using the last of an item a "Heal Which Player? "
prompt would come up
- Fixed a spelling error in battle, it now says "Barely Wounded" not "Wonded"
- Roaming monsters can no longer walk through pushable items or chests
- Fixed a bug where in the inventory screen a long item name would run over
into the item number field (it is now cut off)
- It is now possible to starve to death
- Fixed a bug where you were able to input invalid or negative numbers into
the "How Many: " field when buying multiple items (with strange results)
- Fixed a bug where monsters would continue attacking player 1 even after
he dies
- Fixed transparency problems involving the party icon (ship is shown on the
water now, roofs don't totally cover up the party icon, fixed transparency
issues with party icon+chairs/mirrors)

*

*
Alpha 8B
10/15/99

New Features:
- Two new commands in playgame: [0-6]Set Active PC and [N]ew Order command
- Drop, Look, and F1 (help) work in combat now
- Added two new map event and NPC keyword event types: the text message.
  This will read a .txt file stored in text\ and display it's contents when
  the event is triggered.  Good for signs and long NPC speeches.  The .txt
  file must not be over 2k and must not have any carriage returns except at
  the very end of the file.  2k may _seem_ small, but try actually making a
  2k file and then displaying it in the game, it's enormous.
- When buying items from shopkeepers, you are now prompted "Deal? (Y/N/M)".
  M allows you to buy many of the same item.
- Increased the size limits on the map names, game name, and class names
- Gold now maxes out at 99,999 and food at 999
- A list of commands is now displayed while in the room editor
- New tiles from Geoffrey Jones: the waterfalls, dresser, and torture 
  devices for the dungeons.

Bugfixes:
- Fixed all of the combat bugs that I know of.  This includes the player 1
  bugs where he could attack and move even after dying or running away, the
  invisible blocked areas on the combat screen, and the random weird combat
- In previous versions, if you played for a very long time the program would
  eventually start paging out to disk so badly that the game would become
  unplayable.  This has been fixed.
- Sound support improved (sounds are clearer now)
- You can no longer push chairs out from under NPCs
- You can no longer push torches around
- Monsters which randomly poison should actually do this now (havn't tested,
  the rats in the example game should do this sometimes)
- Fixed a lot of problems in the example game.  Monsters in the hidden
  dungeon are no longer frozen.  The two handed sword is a two handed
  weapon now.  Gold is not quite so plentiful.  Removed the ghost signs in
  the hidden dungeon.  You can no longer walk into the blacksmith's shop
  through the fireplace.  If you have already begun playing the example game
  and dont want to start over, just copy the map files included in this
  archive into your save directory as well as the main game directory.
- When removing a two handed weapon, you no longer end up with two of that
  weapon.

*


*
Alpha 8A
10/13/99

- Fixed a bug that was keeping wandering monsters from wandering
- Fixed a bug in random monster removal code which occurs after battles,
  and was probably causing the strange combat bug

*


*
Alpha 8
10/13/99

First, a couple of warnings if you have already begun work on a game:

- Be sure not to overwrite your exiting game.dat and mapx.map files with 
  the files in the archive, or else your game will be overwritten with the 
  example game.  

- Alpha 8 uses a new format for game.dat and mapx.map files.  It will 
  convert your existing files automatically to the new format.  This seems 
  to work fine.  But I havn't tested it with anything except for the 
  example game, so I suggest keeping a backup.  After running alpha 8 in 
  the directory with your .dat and .map files be sure to examine everything 
  closely and report any problems you have.

Having said that, here is what is new:

- Combat enabled!  
  It works great except there is one bug that I know of:  Sometimes 
  when you are attacked, instead of being taken to the appropriate combat, 
  you'll be warped to a garbled screen with nonsense tiles.  If this 
  happens, run!  Invisible enemys will make short work of you if you dont.
  I'm still trying to trace the cause of this one.  This almost never 
  happens.  I played through the example game, raising all three pcs to 
  level 3, and this only happened once.  
  Features that are noticeably missing: The ability to set an active pc 
  (pause everyone except for one pc), and an option to reorganize the party 
  order.  These will be added soon.
- Added transparency as an option.  When an item, piece of furniture, or 
  an NPC is added to a room, they are drawn on top of the floor tiles,
  instead of being blocked off in their own square.  If you want to use 
  the more traditional look you can disable this in dengine.cfg.
- Sound effects added!  At present the party thumps around as they walk,
  doors and chests open with an appropriate click, and most combat soundfx
  are working.  Thanks to Nathan Kramer for the samples.
- Doubled the tileset!  Two files are now imported for the tileset, 
  tiles.pcx and tiles2.pcx, bringing us to a potential 2048 tiles.
- Added another layer to the maps, the roaming monsters layer.  Create
  bands of wandering monsters in this layer (more in readme.txt)
- Added a new event type, the monster generator (more in readme.txt)
- Did away with the old armor/weapons grouping system and, instead, each
  piece of weapon/armor has a list of class restrictions, allowing you to
  allow/disallow any of the 16 classes the ability to use that item.
- Added a new option for animation: 4 Frame/Pulsating.  Looks great on
  magic doors and items.  This is available both in items and tiles.
- Lots of new tiles and modifictions to existing tiles.  Thanks to Nathan
  Kramer and Geoffrey Jones for their continued good work in this area.
- Several original midi files included with the editor now, songs 21-31.
  Some of these are too quiet, too short, etc, but they are not the final
  versions.  Song 22 is now used for the castle music.  All of these 
  were composed by Nathan Kramer.
- Added a find/replace function to the map editor menu.  Use this to find 
  one tile and replace it with another (more in readme.txt)
- Chests are no longer fixed to item 2.  You can make any item into a 
  chest.  To create a chest, make a pushable type item, and change the 
  class to "Acts As Chest".
- Moved the stats key to Z and added a [S]earch function to the play game 
  engine.
- Pushable items are now called pushable/furniture items, because not 
  all of them are pushable (more below)
- Two new kinds of pushable/furniture items, a Non-Pushable kind (for 
  furniture that can't be pushed) and a search/chest items kind (more 
  in readme.txt)
- Added more NPC keyword events, for healers and trainers
- Added a Zap menu to the map editor (Press Z).  This can be used to wipe 
  out all items, NPCs, events, or roaming monsters on a map.
- Expanded the room editor (more in readme.txt).  Right now this is only 
  used for making the combat screens.
- Added lots of stuff to character classes and will add more soon 
- In the example game, redid all of the existing NPCs and expanded and
  improved upon what was already there.  There is actually quite a bit to
  do now, and the beginnings of the game plot is taking shape.
  There are five maps in the example game now: Stratus (the overworld),
  Castle Sabian, Castle Sabian Level 2, Glenn (the town south of Castle
  Sabian), and a hidden dungeon.  There is another NPC who will join you,
  bringing your potential party total up to 3.  If you can find and beat the
  hidden dungeon, you've won example game 0.4a.  HINT: The dungeon entrance is
  not hidden on the overworld map (Stratus), it is on one of the other maps.
- Fixed several bugs including: the NPC delete bug, the roof delete bug,
  bugs involving quest events and locked doors requiring specific keys,
  among others which I can't recall at the moment.  Thanks to Alex 
  Materra and JP Morris for especially dilligent bug reporting.
- Updated readme.txt (a bit).  Still not as thorough as I'd like it to be but
  I've only got so much time to divide between coding, updating readme.txt,
  and working on the example game.

*

*
Alpha 7c
09/29/99

- Fixed a bug that was causing the program to crash out on machines 
  running MS-DOS without windows.
- You can now press [C] to change layers in the map editor
- The commandline switches "-nomouse" "-faster" "-fastest" "-nosound"
  "-nowin" have been deleted, and dengine.cfg has been expanded.  If 
  you want to toggle sound, mouse support, windows compatibility, or 
  increase the game speed, this is now done by editing dengine.cfg
- Here's a new feature that's been present since 7a but that I forgot
  to list:  There are now more options for tile animation: 
  2 Frames/Faster, 4 Frames/Faster and 4 Frames/Fastest.  Change these 
  under the tile attributes screen.  Note that the fountain in the 
  example game moves much faster now.

*

*
Alpha 7b
09/28/99

This is purely a bugfix release.  Here's whats fixed:
- Fixed a bug that was garbling the view a gem screen.  Try using a gem
  again, it looks much better now.  You can also press [V] from the 
  map editor for the same effect.
- Fixed a bug that was keeping spacebar from letting you pass turns

*

*
Alpha 7a
09/27/99

Here's whats new:
- More new tiles from Geoffrey Jones added (since Alpha 7 he's redone the
  shorelines, roads, rivers, a castle, the hut graphic, among others).
- Changed key for making screen dumps to F10.
- Added a Drop command to the play game engine (Press "D")
- Enter as well as space works for selecting menu options
- The frigate now displays all 4 frames, 1 for each direction of movement.  
  You can assign this to transports from the item editor as well.
- Clocks and the pocketwatch display the time in a more appropriate fashion

And here are some bugs that are fixed:
- Fixed the roof layer.  An example is the open portcullis at the
  entrance to the castle in the example game.  You now walk _under_ it.
- In the example game, turned warparound back on in the overworld map (you
  wont be asked if you want to Leave? anymore, it will wrap back around to
  the other side of the map like it's supposed to).
- Push/pull items works correctly (can no longer push items onto other items
  thereby destroying them).
- You can no longer pick up the frigate or push it onto shore
- Fixed a bug that caused a ghost character to appear if you typed one too
  many characters into an input box (such as the Talk parser)
- Fixed a bug where turns would pass even though you were doing things
- Fixed a text formatting bug that was really only noticeable if you named
  your character a very long name (ie. Archilles) and then tried to [R]eady
  a weapon

*

*
Alpha 7
09/24/99

- There are so many new things that I am bound to forget to list some of
  them here.  I have _not_ tested everthing!  Email me with bugs please.
- Play game is enabled.  Everything except for spells/battles/monsters is
  in there and should work.  I've written the beginnings of an example game
  for you to explore, to get the feel of the play game engine.  If you can
  find all three keys, the teleporters, the ship, the NPC who joins the
  party, and have made it to the second level of the castle, you've seen
  all there is to see so far.  Ignore the town on the south coast please
  (you cant enter it).
- Got an amazing new tileset and font from Josh Steele, and a couple of
  tiles from Geoffrey Jones as well.  Thanks guys.  I still could use some
  more tiles if anyone is interested.
  ** Visit Josh's website at: http://www.moongates.com/u4
- Better video/soundcard support.  Edit dengine.cfg and specify your
  hardware to get the best preformance.  If you are using a standard VGA
  adapter and old soundblaster card you may not need to do this.  
- The format of the mapx.map and game.dat files is FINAL now.  So you can
  begin work on your games in ernest--your game will be compatible with all
  future versions of Dragon Engine.
- Figured out how to compress game.dat and the mapx.map files.  They are
  much smaller and load faster.
- As a result of the compression upped the limits on almost everything.  You
  can have 50 NPCs per map now, 250 different kinds of items, 16 different
  character classes, 100 chest types.
- Events and NPCs have changed somewhat (view readme.txt)
- Items may now be animated
- Added pushable and food type items
- Added mouse support and finished roof layer

*

*
Alpha 6
09/07/99
This is a major release.  Lots of new things were added:
- Added NPCs!  Add them to the map from the map editor (more in 
  readme.txt).  Up to 25 unique NPCs per map.
- Edit Classes from the Edit menu works now!  (more in readme.txt).
  Make up to 8 character classes with different limitations and skills.
- Item #1/2 are now "set" items (cant be changed but can be renamed).
  Item 1 is the game's currency, and Item 2 is the games containers 
  (ie treasure chests).  When adding treasure chests to the map, you'll 
  be asked to provide a type.  Chest types can be changed under the 
  globals menu (more in readme.txt).
- Edit Globals has changed (more in readme.txt).
- game.dat and all the mapx.map files have changed formats again so
  anything you've made in the previous alpha wont work in this one.  
  These files are likely to change formats several more times so 
  dont put a lot of work into your game yet.  I'll let you know once
  it's safe to do so.

*

*
Alpha 5
09/02/99
- Finished items!  Create them under Item Edit from the edit menu, and add
  them to the maps using the map editor.  More in readme.txt
- Added improved keyboard input to the menu.  You can now simply press the 
  first letter of the menu option you want and it will take you there.
- Had to change the map format again.  Sorry your old maps will have to
  be redone.  If you've put a lot of work into one of your maps and you
  would like to save it you could email it to me and I'll email it back
  in the corrected format.
- Took the flashy text effect out of certain messages where it was 
  popping up too often
- Fixed another (final?) bug in the way that tiles are animated.

*

*
Alpha 4
08/30/99
- Added a Main Menu and Edit Menu
- The Edit Globals option from the Edit Menu works.  This lets you
  change some settings such as the game name, etc.
- Added a flashy effect to some of the text messages
- Added a fifth layer for portals and special map events.  So the layers
  are now: Ground Level/Portals and Events/Items/NPCs/Roofs.
- The portals and events layer is fully functional, although I need to add
  more map event types.  You can create portals.
- Added tons of keyboard shortcuts to the map editor 
  (view readme.txt for documentation of the new features)
- Fixed a bug in the way that tiles were animated
- Renamed the main executable from mapedit.exe to dengine.exe
- Map names are now stored in the file maps.txt.  Edit this using a
  text editor.

*

*
Alpha 3
08/27/99

- Changes that you make in the Edit Tiles screen are saved and reloaded
  automatically when you run the editor again
- Map1.map auto-loads when you run the program
- Added save/load map to the menus
- I figured out how I want to do items/npcs/roofs.  There will be 4 layers
  to each map, the ground level, items layer, NPC layer, and roof layer.  You
  can toggle between these layers from the menu now but they dont really
  work yet.  But you can get the idea of how it is going to work ...
- Cleaned up some code

*

*
Alpha 2
08/26/99

- The ability to save/load the main map
- Screenshot capability
- Animation!  

*

